阅读 1386

Cocoapods 常用操作

安装

首先切换源,非必须如果你能正常安装就不用切换

gem source -l
#如果输出以下就代表是原来的
*** CURRENT SOURCES ***

https://rubygems.org/

#删除ruby源
gem sources --remove https://rubygems.org/
#添加新的ruby源
gem sources -a https://gems.ruby-china.com/
复制代码

开始安装

#安装或更新
sudo gem install -n /usr/local/bin cocoapods
#指定某个版本
sudo gem install -n /usr/local/bin cocoapods -v 1.5.0
#查看正确输出就代表安装成功
pod --version
#创建本地中央仓库保存spec-repos
pod setup
复制代码

卸载

sudo gem uninstall cocoapods
复制代码

升级cocopod时可能需要升级ruby

#检查rvm版本
ruby -v
#升级rvm
curl -L get.rvm.io | bash -s stable
#安装指定的ruby
rvm install 2.4
复制代码

使用

1、初始化

pod init 执行后之后会在项目根目录下生成podfile文件,当然你也可以不用这个命令直接创建一个文件,以后开发都会使用到它,这里列下podfile的大部分用法

#井号为备注标识

#设置源,一般我们有自己的私有库时这个是很重要的属性,以下这一行为默认源,如果你没有私有库可以不写
source 'https://github.com/CocoaPods/Specs.git'
#源可以有多个
source 'https://github.com/CocoaPods/Specs2.git'

#pod的hooks可以定义自己的一些配置   post_install指在写入硬盘或者其他你想执行的操作前做最后的改动
post_install do |installer|
  installer.pods_project.targets.each do |target|
    target.build_configurations.each do |config|
      config.build_settings['GCC_ENABLE_OBJC_GC'] = 'supported'
    end
  end
end

#pre_install这个钩子允许你在Pods被下载后但是还未安装前对Pods做一些改变


#指定一个工作空间
workspace 'MyWorkspace'

#支持的版本
platform :ios, '8.0'
#屏蔽所有警告
inhibit_all_warnings!

#两个target使用同一个pod库
link_with 'testDemo', 'testDemo1' 

#设置该pod对应的target项目必须和项目名称一样才会生效
target 'testDemo' do
  #用framework的pod替代静态库的
  use_frameworks!

  #依赖相关 pod '库名称','版本'
  #依赖AFN,没写版本代表获取最新的版本
  pod 'AFNetworking'
  #获取指定版本
  pod 'AFNetworking','3.0'
  #获取高于3.0的版本
  pod 'AFNetworking','>3.0'
  #获取3.0及高于3.0的版本
  pod 'AFNetworking','>=3.0'
  #获取低于3.0的版本
  pod 'AFNetworking','<3.0'
  #获取3.0及低于3.0的版本
  pod 'AFNetworking','<=3.0'
  #获取3.0到4.0以下的任何版本,一般这个用的最多
  pod 'AFNetworking','~>3.0'
  #使用header最新版本,慎用
  pod 'Objection', :head

  #使用本地的源码,后面的路径为本地项目的podsepc所在的文件夹
  pod 'AFNetworking', :path => '~/Documents/AFNetworking'
  #使用仓库的master分支的代码
  pod 'AFNetworking', :git => 'https://github.com/gowalla/AFNetworking.git'
  #使用仓库的其他分支:
  pod 'AFNetworking', :git => 'https://github.com/gowalla/AFNetworking.git', :branch => 'dev'
  #使用某个tag作为源码
  pod 'AFNetworking', :git => 'https://github.com/gowalla/AFNetworking.git', :tag => '0.7.0'
  #使用某个提交记录作为代码
  pod 'AFNetworking', :git => 'https://github.com/gowalla/AFNetworking.git', :commit => '082f8319af'

end

#在测试的taget中加入ocmock
target 'testDemoTests' do
    inherit! :search_paths 
    pod 'OCMock', '~> 2.0.1' 
end
复制代码
2、搜索某个库的版本

pod search AFNetworking

3、下载podfile的所有库

pod install

4、更新podfile的库

pod install #pod install 在执行的时候每次都会先执行pod repo update,比较耗时,所以一般选择不更新只使用本地仓库的版本 pod install --no-repo-update

5、更新库

pod update #pod update 同样的可以只使用本地仓库的版本 pod update --no-repo-update

6、更新本地索引库

#更新本地所有库 pod repo update #更新本地指定库 pod repo update master

7、只更新某个库

#只更新afn pod update AFNetworking

8、指定cocopods的版本进行操作

#指定1.5.0版本进行更新 pod 1.5.0 update

9、创建podspec 文件

#pod spec create 名称 git地址,git可以帮助填充podspec里面的许可、版本、作者信息等 pod spec create testDemo git@github.com:GuoMs/testDemo.git podsepc的大概信息

podsepc的开头
Pod::Spec.new do |s|
  #项目名称
  s.name         = "testDemo"
  #编译平台必要的属性
  s.platform         = :ios, '8.0'
  #项目版本
  s.version      = "0.0.1"
  #项目的简短描述会出现在pod search的结果里面
  s.summary      = "A short description of testDemo."
  #项目的长描述
  s.description  = <<-DESC
                   DESC
  #项目的主页
  s.homepage     = "http://EXAMPLE/testDemo"
  #开源协议许可类型
  s.license      = "MIT (example)"
  #使用arc
  s.requires_arc     = true
  #作者信息
  s.author             = { "xxx" => "gz3024@aliyun.com" }
  #代码的源地址,就是放代码真正的地方
  s.source       = { :git => "http://EXAMPLE/testDemo.git", :tag => "#{s.version}" }
  #资源路径
  s.resource_bundles  = "Resources/*.png"
  #代码文件搜索的路径
  s.source_files  = "Classes", "Classes/**/*.{h,m}"
  s.exclude_files = "Classes/Exclude"
  #需要依赖的第三方库
  s.dependency 'AFNetworking', '~>3.1.0'
  #依赖非系统的静态库,需要以lib开头命名
  s.vendored_libraries = 'Frameworks/libZCPKit.a' 
  #子目录的代码,pod里面子目录显示
  s.subspec 'SUBView' do |ss|
    ss.source_files = 'ZXCategory/UIView/*.{h,m}'
  end
  
end
复制代码

指定 cocoapods 版本

  • 指定版本 sudo gem install cocoapods -v 1.6.1
  • 最新版本 sudo gem install cocoapods